module debounce
	#(
		parameter limit = 20'd650000
	) (
		input wire clock,
		input wire in,
		output wire out
	);

reg [19:0] counter; // observatie: si circuitul de debounce foloseste un numarator
reg hit;

assign out = (counter == limit);

always@(posedge clock) 
begin
	if(in == 0) 
		begin
		counter <= 0;
		hit <= 0;        
		end 
	else 
		begin
		if(counter == limit) 
			begin
			hit <= 1;
			counter <= counter + 1;
			end 
		else 
			begin
			if(in == 1 & hit == 0) 
				begin
				counter <= counter + 1;
				end
			end
		end
end

endmodule
















